'finalna verzija

$crystal = 16000000
$regfile = "m328pdef.dat"
'$regfile = "m168def.dat"
$hwstack = 48
$swstack = 32
$framesize = 48

Config Clockdiv = 1

Waitms 500

$include "DS3231$SE.sub"

Dim Hh As Byte , Mm As Byte , Ss As Byte
Dim Hh_old As Byte , Mm_old As Byte , Ss_old As Byte
Dim Hh_led(12) As Byte , Mm_led(12) As Byte
Dim Hh_ind As Byte , Mm_ind As Byte
Dim I As Byte , Set_indeks As Byte
Dim T_button As Byte , Disp_count As Byte

H12_05 Alias Portb.2
H06_11 Alias Portb.4
M00_25 Alias Portb.1
M30_55 Alias Portb.0

H01m05 Alias Portd.3
H02m10 Alias Portd.2
H03m15 Alias Portd.7
H04m20 Alias Portd.6
H05m25 Alias Portd.5
H06m30 Alias Portd.5
H07m35 Alias Portd.6
H08m40 Alias Portd.7
H09m45 Alias Portd.2
H10m50 Alias Portd.3
H11m55 Alias Portd.4
H12m00 Alias Portd.4

H12_05 = 0 : Config H12_05 = Output
H06_11 = 0 : Config H06_11 = Output
M00_25 = 0 : Config M00_25 = Output
M30_55 = 0 : Config M30_55 = Output

H12m00 = 1 : Config H12m00 = Output
H01m05 = 1 : Config H01m05 = Output
H02m10 = 1 : Config H02m10 = Output
H03m15 = 1 : Config H03m15 = Output
H04m20 = 1 : Config H04m20 = Output
H05m25 = 1 : Config H05m25 = Output

Set_button Alias Pinc.0
Portc.0 = 1 : Config Set_button = Input

Sqw Alias Pinc.3
Portc.3 = 1 : Config Sqw = Input

Config Sda = Portc.5
Config Scl = Portc.4
I2cinit
Waitms 10

Compare0a = 128
Config Timer0 = Timer , Prescale = 8 , Clear_timer = 1 , Compare_a = Disconnect
On Compare0a Disp
Enable Compare0a
Enable Interrupts

Config Timer2 = Timer , Prescale = 1024 , Compare_a = Toggle , Clear_timer = 1
Stop Timer2
Compare2a = 200

Ds3231$write_control &B00000000

Hh_old = 255
Mm_old = 255

Do
  Debounce Set_button , 0 , Set_time , Sub
  If Set_indeks = 0 Then
    Waitms 20
    Stop Timer2
    Gosub Read_hhmmss
    If Ss <> Ss_old Then
      Ss_old = Ss
      Start Timer2
    End If
    If Mm <> Mm_old Or Hh <> Hh_old Then
      Mm_old = Mm
      Hh_old = Hh
      Gosub Disp_mm
      Gosub Disp_hh
    End If
  End If
Loop

End

Set_time:
  T_button = 0
  While Set_button = 0
    Waitms 10
    Incr T_button
    If T_button > 100 Then Exit While
  Wend
  If T_button > 100 Then
    If Set_indeks = 0 Then
      Set_indeks = 1
      Gosub Blink_hh
      Gosub Disp_hh
    Elseif Set_indeks = 1 Then
      Set_indeks = 2
      Gosub Blink_mm
      Gosub Disp_mm
    Else
      Set_indeks = 0
      Ss = 0
      Gosub Write_hhmmss
      Gosub Blink_hh
      Gosub Blink_mm
      Gosub Disp_hh
      Gosub Disp_mm
    End If
  Else
    If Set_indeks = 1 Then
      Incr Hh
      If Hh > 23 Then Hh = 0
      Gosub Disp_hh
    Elseif Set_indeks = 2 Then
      Incr Mm
      If Mm > 59 Then Mm = 0
      Gosub Disp_mm
    End If
  End If
Return

Read_hhmmss:
  Ds3231$read
  Hh = Makedec(ds3231$hour)
  Mm = Makedec(ds3231$min)
  Ss = Makedec(ds3231$sec)
Return

Write_hhmmss:
  Ds3231$hour = Makebcd(hh)
  Ds3231$min = Makebcd(mm)
  Ds3231$sec = Makebcd(ss)
  Ds3231$write_time
Return

Blink_mm:
  For I = 1 To 12
    Hh_led(i) = 0
    Mm_led(i) = 0
  Next
  Waitms 250
  Mm_led(1) = 255
  For I = 1 To 11
    Waitms 50
    Mm_led(i) = 0
    Mm_led(i + 1) = 255
  Next
  Waitms 50
  Mm_led(12) = 0
Return

Disp_mm:
  For Mm_ind = 1 To 12
    Mm_led(mm_ind) = 0
  Next
  Mm_ind = Mm / 5
  Incr Mm_ind
  I = Mm Mod 5
  Mm_led(mm_ind) = Lookup(i , Mm_led_table)
  If Mm_ind < 12 Then
    Incr Mm_ind
  Else
    Mm_ind = 1
  End If
  I = 5 - I
  Mm_led(mm_ind) = Lookup(i , Mm_led_table)
Return

Mm_led_table:
Data 64
Data 32
Data 16
Data 8
Data 4
Data 0

Blink_hh:
  For I = 1 To 12
    Hh_led(i) = 0
    Mm_led(i) = 0
  Next
  Waitms 250
  Hh_led(1) = 255
  For I = 1 To 11
    Waitms 50
    Hh_led(i) = 0
    Hh_led(i + 1) = 255
  Next
  Waitms 50
  Hh_led(12) = 0
Return

Disp_hh:
  For Hh_ind = 1 To 12
    Hh_led(hh_ind) = 0
  Next
  I = Mm + 4
  I = I / 5
  If Set_indeks = 1 Then I = 0
  If Hh < 12 Then
    Hh_ind = Hh + 1
  Else
    Hh_ind = Hh - 11
  End If
  Hh_led(hh_ind) = Lookup(i , Hh_led_table)
  If Set_indeks = 0 Then
    If Hh_ind < 12 Then
      Incr Hh_ind
    Else
      Hh_ind = 1
    End If
    I = 13 - I
    Hh_led(hh_ind) = Lookup(i , Hh_led_table)
  End If
Return

Hh_led_table:
Data 64
Data 48
Data 32
Data 24
Data 16
Data 12
Data 8
Data 8
Data 6
Data 4
Data 3
Data 2
Data 1
Data 0

Disp:
  If H12_05 = 1 Then
    H12_05 = 0
    Gosub Disp_h06_11
    H06_11 = 1
  Elseif H06_11 = 1 Then
    H06_11 = 0
    Gosub Disp_m00_25
    M00_25 = 1
  Elseif M00_25 = 1 Then
    M00_25 = 0
    Gosub Disp_m30_55
    M30_55 = 1
  Else
    M30_55 = 0
    Gosub Disp_h12_05
    H12_05 = 1
    Incr Disp_count
    If Disp_count > 63 Then Disp_count = 0
  End If
Return

Disp_h12_05:
  If Hh_led(1) > Disp_count Then
    H12m00 = 0
  Else
    H12m00 = 1
  End If
  If Hh_led(2) > Disp_count Then
    H01m05 = 0
  Else
    H01m05 = 1
  End If
  If Hh_led(3) > Disp_count Then
    H02m10 = 0
  Else
    H02m10 = 1
  End If
  If Hh_led(4) > Disp_count Then
    H03m15 = 0
  Else
    H03m15 = 1
  End If
  If Hh_led(5) > Disp_count Then
    H04m20 = 0
  Else
    H04m20 = 1
  End If
  If Hh_led(6) > Disp_count Then
    H05m25 = 0
  Else
    H05m25 = 1
  End If
Return

Disp_h06_11:
  If Hh_led(7) > Disp_count Then
    H06m30 = 0
  Else
    H06m30 = 1
  End If
  If Hh_led(8) > Disp_count Then
    H07m35 = 0
  Else
    H07m35 = 1
  End If
  If Hh_led(9) > Disp_count Then
    H08m40 = 0
  Else
    H08m40 = 1
  End If
  If Hh_led(10) > Disp_count Then
    H09m45 = 0
  Else
    H09m45 = 1
  End If
  If Hh_led(11) > Disp_count Then
    H10m50 = 0
  Else
    H10m50 = 1
  End If
  If Hh_led(12) > Disp_count Then
    H11m55 = 0
  Else
    H11m55 = 1
  End If
Return

Disp_m00_25:
  If Mm_led(1) > Disp_count Then
    H12m00 = 0
  Else
    H12m00 = 1
  End If
  If Mm_led(2) > Disp_count Then
    H01m05 = 0
  Else
    H01m05 = 1
  End If
  If Mm_led(3) > Disp_count Then
    H02m10 = 0
  Else
    H02m10 = 1
  End If
  If Mm_led(4) > Disp_count Then
    H03m15 = 0
  Else
    H03m15 = 1
  End If
  If Mm_led(5) > Disp_count Then
    H04m20 = 0
  Else
    H04m20 = 1
  End If
  If Mm_led(6) > Disp_count Then
    H05m25 = 0
  Else
    H05m25 = 1
  End If
Return

Disp_m30_55:
  If Mm_led(7) > Disp_count Then
    H06m30 = 0
  Else
    H06m30 = 1
  End If
  If Mm_led(8) > Disp_count Then
    H07m35 = 0
  Else
    H07m35 = 1
  End If
  If Mm_led(9) > Disp_count Then
    H08m40 = 0
  Else
    H08m40 = 1
  End If
  If Mm_led(10) > Disp_count Then
    H09m45 = 0
  Else
    H09m45 = 1
  End If
  If Mm_led(11) > Disp_count Then
    H10m50 = 0
  Else
    H10m50 = 1
  End If
  If Mm_led(12) > Disp_count Then
    H11m55 = 0
  Else
    H11m55 = 1
  End If
Return
